<?php 

namespace Management\Services;

use Doctrine\ORM\EntityManager;
use Management\Util;

class UnidadeService {

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

	public function getUnidades($CDOPERADOR, $NRORG) {
		$params = array(
			':CDOPERADOR' => $CDOPERADOR,
			':NRORG' => $NRORG		
		);
		return $this->entityManager->getConnection()->fetchAll(self::GET_UNIDADES, $params);
	}
	
	const GET_UNIDADES = "
		SELECT F.*, FO.CDOPERADOR, F.CDFILIAL || ' -- ' || F.NMFILIAL AS LABELFILIAL, PA.CDPAIS, PA.NMPAIS, RE.NMREGIAO, 
			   ES.SGESTADO, ES.NMESTADO, MU.CDMUNICIPIO, MU.NMMUNICIPIO 
		  FROM FILIAL F 
		  JOIN FILIOPER FO 
		    ON F.CDFILIAL = FO.CDFILIAL 
		  JOIN ENDEFILI EM 
		    ON F.CDFILIAL = EM.CDFILIAL 
		   AND F.NRORG = EM.NRORG 
		  LEFT JOIN PAIS PA 
		    ON EM.CDPAIS = PA.CDPAIS 
		   AND EM.NRORG = PA.NRORG 
		  LEFT JOIN ESTADO ES 
			ON EM.CDPAIS = ES.CDPAIS 
		   AND EM.SGESTADO = ES.SGESTADO 
		   AND EM.NRORG = ES.NRORG 
		  LEFT JOIN MUNICIPIO MU 
		    ON EM.CDPAIS = MU.CDPAIS 
		   AND EM.SGESTADO = MU.SGESTADO 
		   AND EM.CDMUNICIPIO = MU.CDMUNICIPIO 
		   AND EM.NRORG = MU.NRORG 
		  LEFT JOIN REGIAO RE 
		    ON F.CDREGIAO = RE.CDREGIAO 
		   AND EM.CDPAIS = RE.CDPAIS 
		   AND EM.SGESTADO = RE.SGESTADO 
		   AND EM.NRORG = RE.NRORG 
		 WHERE FO.CDOPERADOR = :CDOPERADOR 
		   AND F.NRORG = :NRORG 
		   AND EM.IDTPENDEFILI = 'P' 
		   AND F.IDSTATUSBLOQ = 'N' 
		   AND (FO.DTVALIDADE IS NULL OR ( TRUNC(FO.DTVALIDADE) >= TRUNC(SYSDATE) )) 
		 ORDER BY FO.CDFILIAL ASC, F.NMFILIAL ASC
	";
	
} 