// FILE: ./assets/js/services/DashboardCorporativoService.js
function DashboardCorporativoService (restEngine) {
    
    this.getV_QTTICKET = function( CDFILIAL, DTVNDCARDS, CHECK) {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": (CDFILIAL == null ? getLocalVar('CDFILIAL') : CDFILIAL)
            },
            {
                "name": "DTVNDCARDS",
                "operator": "=",
                "value": (DTVNDCARDS == null ? moment().format('DD/MM/YYYY') : DTVNDCARDS)
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "name": "CHECK",
                "operator": "=",
                "value": CHECK
            }
        ];

         return restEngine.post(
            'product#/getV_QTTICKET', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('DashboardCorporativoService', DashboardCorporativoService);
});

/* global Configuration */
/* global getLocalVar */
/* global moment */

// FILE: ./assets/js/services/GRManageDashboardService.js
function GRManageDashboardService (restEngine) {
    
    this.getCaixaPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            }
        ];

         return restEngine.post(
            'product#/getFechamentoCaixaPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getConsolidacaoPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            }
        ];

         return restEngine.post(
            'product#/getConsolidacaoVendaPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getCupomPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            }
        ];

         return restEngine.post(
            'product#/getFechamentoCupomPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('GRManageDashboardService', GRManageDashboardService);
});

// FILE: ./assets/js/services/ManageDashboardService.js
function ManageDashboardService (restEngine) {
    
    this.getCaixaPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }
        ];

         return restEngine.post(
            'product#/getFechamentoCaixaPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getConsolidacaoPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }
        ];

         return restEngine.post(
            'product#/getConsolidacaoVendaPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getCupomPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }
        ];

         return restEngine.post(
            'product#/getFechamentoCupomPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getVendasDiarias = function(DTATUAL) {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            },
            {
                "name": "DTENTRVENDA",
                "operator": "=",
                "value": DTATUAL
            }
        ];

        return restEngine.post(
            'product#/getVendasDiarias', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };

    this.getProdutosMaisVendidos = function(DTATUAL) {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            },
            {
                "name": "DTENTRVENDA",
                "operator": "=",
                "value": DTATUAL
            }
        ];

        return restEngine.post(
            'product#/getProdutosMaisVendidos', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getDivergenciasConciliacao = function() {
        var data = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            }
        ];
        
        return restEngine.post(
            'product#/getDivergenciasConciliacao', {
                'requestType': 'FilterData',
                'filter': data
            }, undefined, undefined, undefined, undefined, 8001000
        );  
    };
    
    // Util method to request modules redirect.
	this.requestModulesMetadata = function () {
		var modulesPackage = window.modulesPackage || "modules";
		return restEngine.requestMetaData(modulesPackage + "#json/modules.json").then(function (response) {
			return response.data;
		});
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ManageDashboardService', ManageDashboardService);
});

// FILE: ./assets/js/controllers/ChartController.js
function ChartController() {
 
    this.setWidgetChartSeries = function(widget, chartSeries) {
      widget.chartSeries = chartSeries;
    };
    
    
}

Configuration(function(ContextRegister) {
	ContextRegister.register('ChartController', ChartController);
});

/* global Configuration */
/* global getLocalVar */

// FILE: ./assets/js/controllers/ChartFactoryController.js
function ChartFactoryController() {
 
    this.getBarChart = function(color, serieFields, serieLabels, fieldSort, stacked) {
        
        if(!stacked)
            stacked = false;
            
        var chartSeries = {
                            "serieType": "bar",
                            "serieStacked": stacked,
                            "serieSort": fieldSort,
                            "serieColors": color,
                            "serieFields": serieFields,
                            "serieLabels": serieLabels,
                            "serieShowValueLabels": true,
                            "serieYAxisFormat": "currency"
                         };
                         
        return chartSeries;
    };
    
    this.getPieChart = function(color, nameLabel, valorLabel, fieldSort) {
      var chartSeries = {
							"serieType": "pie",
							"serieSort": fieldSort,
							"serieColors": color,
							"serieFieldLabel": nameLabel,
							"serieFieldValue": valorLabel,
							"serieShowValueLabels": false,
							"serieValueFormat": "currency"
						};
                         
        return chartSeries;
    };
    
    this.getDonutChart = function(nameLabel, valorLabel, fieldSort, color) {
      var chartSeries = {
							"serieType": "donut",
    						"serieSort": fieldSort,
    						"serieColors": color,
    						"serieFieldLabel": nameLabel,
    						"serieFieldValue": valorLabel,
    						"serieValueFormat": "currency"
						};
                         
        return chartSeries;
    };
    
    this.getAreaChart = function(nameLabel, valorLabel, color, marksize) {
      var chartSeries = {
                            "serieType": "area",
                            "serieStacked": false,
                            "serieLineType": "monotone",
                            "serieLineWidth": 0,
                            "serieColors": color,
                            "serieFields": valorLabel,
                            "serieLabels": nameLabel,
                            "serieYAxisFormat": "currency",
                            "serieLineMarkSize": marksize,
                            "serieShowValueLabels": false
                        };
                         
        return chartSeries;
    };
    
    this.getAreaChartDouble = function(nameLabel, valorLabel, color, marksize) {
      var chartSeries = {
                            "serieType": "area",
                            "serieStacked": false,
                            "serieLineType": "monotone",
                            "serieLineWidth": 0,
                            "serieColors": color,
                            "serieFields": valorLabel,
                            "serieLabels": nameLabel,
                            "serieYAxisFormat": "currency",
                            "serieLineMarkSize": marksize,
                            "serieShowValueLabels": false
                        };
                         
        return chartSeries;
    };
    
    this.getLineChart = function(nameLabel, valorLabel, serieLineWidth) {
      var chartSeries = {
                            "serieType": "line",
                            "serieStacked": false,
                            "serieLineType": "monotone",
                            "serieLineWidth": serieLineWidth,
                            "serieYAxisLinkedSerie": 0,
                            "serieColors": "#d81b60",
                            "serieFields": valorLabel,
                            "serieLabels": nameLabel,
                            "serieYAxisFormat": "currency",
                            "serieShowValueLabels": false,
                            "serieLineMarkSize": 6,
                            "serieLineMarkType": "circle"
                        };
                         
        return chartSeries;
    };
    
    this.getLineChartTriangle = function(nameLabel, valorLabel, serieLineWidth) {
      var chartSeries = {
                            "serieType": "line",
                            "serieStacked": false,
                            "serieLineType": "monotone",
                            "serieLineWidth": serieLineWidth,
                            "serieYAxisLinkedSerie": 0,
                            "serieColors": "#6D1A6A",
                            "serieFields": valorLabel,
                            "serieLabels": nameLabel,
                            "serieYAxisFormat": "currency",
                            "serieShowValueLabels": false,
                            "serieLineMarkSize": 10,
                            "serieLineMarkType": "triangle-up"
                        };
                         
        return chartSeries;
    };
    
    this.getProgressChart = function(valor, valorMaximo) {
      var chartSeries = {
							"serieType": "progress",
							"serieColors": "#1abc9c",
    						"serieValue": valor,
							"serieMaxValue": valorMaximo,
							"serieShowValueLabels": "%",
							"serieShowProgressValue": "value",
							"serieValueFormat": "currency"
						};
                         
        return chartSeries;
    };
    
}

Configuration(function(ContextRegister) {
	ContextRegister.register('ChartFactoryController', ChartFactoryController);
});

/* global Configuration */
/* global getLocalVar */

// FILE: ./assets/js/controllers/MainDashboardController.js
function MainDashboardController(eventAggregator, templateManager, ScreenService, restEngine, ChartFactoryController, ChartController) {

	var self = this;

	var EVENT_LOGIN_SUCCESS = 'onAllLocalVarsSetted';
	var SALES_CONCLUDED = 'V_QTTICKET';
	var SALES_CANCELED = 'V_CANCTICKET';
	
	// nome das widget dos cards na ordem da tela V_QTTICKET
	// nome das widget dos cards na ordem da tela V_TOTVEND
	// nome das widget dos cards na ordem da tela V_AVGTICKET
	// nome das widget dos cards na ordem da tela V_CANCTICKET
	// nome das widget dos cards na ordem da tela V_FECHACAIXAPEND
	// nome das widget dos cards na ordem da tela V_APROVMOVCARD
	// nome das widget dos cards na ordem da tela V_DIFAPURACARD
	// nome das widget dos cards na ordem da tela V_QTDIFAPURACARD
	// nome das widget dos cards na ordem da tela V_CUPOMPENDCARD
	// nome das widget dos cards na ordem da tela V_ITESTPENDCARD

	var LABEL_VENDAS_REALI = 'Vendas Realizadas/Dia';
	var LABEL_INFO_VND_UNI = 'Vendas Realizadas hoje - Por Unidade';
	var LABEL_INFO_VND_MOD = 'Vendas Realizadas por Modalidade/Dia';

	var LABEL_ACUMULAD_VND = 'Vendas Acumuladas/Dia';
	var LABEL_INFO_VND_ACM = 'Vendas realizadas hoje - Hora a Hora Acumuladas';

	var LABEL_PARTIC_VENDA = 'Venda por Unidade/Dia (Porcentagem)';

	var LABEL_CUMPRI_METAS = 'Vendas x Meta Acumulada';

	var LABEL_INFO_VND_TOT = 'Vendas realizadas hoje - Totalizado';
	var LABEL_INFO_TCK_UNI = 'Ticket Médio - Média Por Unidade';
	var LABEL_INFO_TCK_TOT = 'Ticket Médio - Média Geral';

	var TODAS_UNIDADES = 'T'; // Totalizado
	var POR_UNIDADE = 'S'; // Segmentado
	var MAIORES_VENDAS = 'M'; // Maior
	var POR_MODALIDADE = 'P'; // Por Unidade Por Modalidade
	
	var ICONCONFIG_VENDASDODIA = "back";
	var ICONCONFIG_VENDASTOTAL = "back";

	//eventAggregator.subscribe(EVENT_LOGIN_SUCCESS, initializeDashboardValues);

	//function initializeDashboardValues() {
	//	getDashboardData();
	//}


	// Number.prototype.isInt = function() {
	// 	return this % 1 === 0;
	// };

	// Number.prototype.formatMoney = function(c, d, t) {
	// 	var n = this;
			
	// 		c = isNaN(c = Math.abs(c)) ? 2 : c;
	// 		d = d == undefined ? "." : d;
	// 		t = t == undefined ? "," : t;
			
	// 	var	s = n < 0 ? "-" : "",
	// 		i = String(parseInt(n = Math.abs(Number(n) || 0).toFixed(c))),
	// 		j = (j = i.length) > 3 ? j % 3 : 0;
			
	// 	return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
	// };

	// Number.prototype.toMoney = function() {
	// 	var treated = "";
	// 	var splited = this.toString().split('.');
	// 	if (parseFloat(this).isInt()) {
	// 		treated = this + ',00';
	// 	}
	// 	else if (parseFloat(splited[1]) < 10) {
	// 		splited[1] += '0';
	// 		treated = splited[0] + ',' + splited[1];
	// 	}
	// 	else {
	// 		treated = this;
	// 	}

	// 	treated = treated.replace('.', ',');
	// 	treated = 'R$ ' + treated;
	// 	return treated;
	// };
	/* Cuida do gráfico de vendas realizadas
	   Troca de acordo com a visualização solicitada.
	*/
	this.trocarGraficoVendasRealizadas = function(inicializacao) {

		var widget = getWidgetVendasRealizadas();
		var grafico;

		if (widget.unidades > 1 || inicializacao) {
			// Verifica se o gráfico está como Maior Venda ou como segmentado por unidade		
			if (widget.tipoVisualizacao == MAIORES_VENDAS) {

				widget.configButtonIcon = "";
				widget.label = LABEL_VENDAS_REALI;
				widget.labelInfo = LABEL_INFO_VND_UNI + " - Totalizado: R$ " + templateManager.container.allData.totalVendas[0].TOTALVEND.formatMoney(2, ',', '.');

				widget.tipoVisualizacao = POR_UNIDADE;

				widget.chartXAxisField = "LABELFILIAL";
				widget.chartXAxisTicksMaxLines = 10;
				widget.chartXAxisTicksMaxWidth = 65;
				widget.chartXAxisBandDimensionMinWidth = 60;


				grafico = [ChartFactoryController.getBarChart('#21634f', 'TOTALVEND', 'Total de Vendas', 'TOTALVEND'),
					ChartFactoryController.getLineChart('Meta Acumulada', 'META', 0)
				];

			}
			else if (widget.tipoVisualizacao == POR_UNIDADE) {

				widget.configButtonIcon = ICONCONFIG_VENDASDODIA;
				widget.label = LABEL_ACUMULAD_VND;
				widget.labelInfo = widget.currentRow.LABELFILIAL + " - Total vendido: R$ " + widget.currentRow.DADOSMETA[0].TOTALVEND.formatMoney(2, ',', '.');

				widget.tipoVisualizacao = MAIORES_VENDAS;

				widget.chartXAxisField = "DATA";
				widget.chartXAxisTicksMaxLines = 10;
				widget.chartXAxisTicksMaxWidth = 45;
				widget.chartXAxisBandDimensionMinWidth = 15;
				
				grafico = [ChartFactoryController.getAreaChart(['Total Vendido', 'Meta Acumulada'], ['TOTALVEND', 'META'], ["#66b9bf", "#eeaa7b"], 6),
					ChartFactoryController.getLineChartTriangle('Posição Atual', 'HORAATUAL', 0)
				];
			}


			self.inicializar(widget, grafico);
			self.inicializar(getWidgetDonutVendas(), trocarGraficoMeta());
		}

	};

	var trocarGraficoMeta = function(inicializacao) {

		var widget = getWidgetDonutVendas();
		var widgetVendas = getWidgetVendasRealizadas();
		var grafico;

		var serieFieldLabel = "LABELFILIAL";
		var serieFieldValue = "TOTALVEND";
		var serieSort;
		var serieColors;

		widget.tipoVisualizacao = "DONUTVENDAS";

		if (widgetVendas.tipoVisualizacao == POR_UNIDADE) {

			widget.label = LABEL_PARTIC_VENDA;
			widget.labelInfo = LABEL_INFO_VND_TOT + ": R$ " + templateManager.container.allData.totalVendas[0].TOTALVEND.formatMoney(2, ',', '.');

			setDonutVendas();

			serieSort = "value";
			serieColors = ["#80cbc4", "#00838f", "#0288d1", "#1e88e5", "#3f51b5", "#7e57c2"];

			grafico = [ChartFactoryController.getDonutChart(serieFieldLabel, serieFieldValue, serieSort, serieColors)];
		}
		else {
			var porcentagemUltrapassada;
			
			if (widgetVendas.currentRow.DADOSMETA[0].META > 0) 
				porcentagemUltrapassada = (widgetVendas.currentRow.DADOSMETA[0].TOTALVEND * 100) / widgetVendas.currentRow.DADOSMETA[0].META;
			else 
				porcentagemUltrapassada = widgetVendas.currentRow.DADOSMETA[0].TOTALVEND;
				
			widget.label = LABEL_CUMPRI_METAS;
			widget.labelInfo = widgetVendas.currentRow.LABELFILIAL + " - Meta acumulada: R$ " + widgetVendas.currentRow.DADOSMETA[0].META.formatMoney(2, ',', '.') +
				". Porcentagem alcançada: " + porcentagemUltrapassada.toFixed(2) + "%";

			var cdfilial = widgetVendas.currentRow.LABELFILIAL.substring(0, 4);
			setDonutVendasMeta(cdfilial);

			serieColors = ["#1abc9c", "#e65100"];
			serieSort = false;

		}

		grafico = [ChartFactoryController.getDonutChart(serieFieldLabel, serieFieldValue, serieSort, serieColors)];

		return grafico;
	};

	this.trocarGraficoVendaModalidade = function(inicializacao) {

		var widget = getWidgetVendaModalidade();
		var grafico;
		var serieColors = ["#750568", "#80C8B5", "#4d62b7", "#E6C973", "#e673d4", "#6ae2dc"];
		var unidades = getWidgetVendasRealizadas().dataSourcePorUnidade.data.length;
		var tipoVisualizacao = widget.tipoVisualizacao;

		if (unidades > 1 || inicializacao) {
			if (tipoVisualizacao == TODAS_UNIDADES) {

				widget.tipoVisualizacao = POR_UNIDADE;
				widget.labelInfo = LABEL_INFO_VND_UNI;

				widget.chartXAxisField = "UNIDADE";

				var serieFields = ["MES", "BAL", "DLV", "TAA", "CMD", "OUTROS"];
				var serieLabels = ["Mesa", "Balcão", "Delivery", "TAA", "Comanda", "Outros"];

				grafico = [ChartFactoryController.getBarChart(serieColors, serieFields, serieLabels, 'value', true),
					ChartFactoryController.getLineChart('Meta do Dia', 'META', 0)
				];
				
				widget.configButtonIcon = ICONCONFIG_VENDASTOTAL;

			}
			else if (tipoVisualizacao == POR_UNIDADE) {

				widget.tipoVisualizacao = POR_MODALIDADE;

				widget.chartXAxisField = "MODALIDADE";
				serieColors = ["#3f9669"];

				grafico = [ChartFactoryController.getBarChart(serieColors, "TOTALVEND", "Total Vendas", 'TOTALVEND', false),
					ChartFactoryController.getLineChart('Meta', 'META', 0)
				];

				widget.configButtonIcon = ICONCONFIG_VENDASTOTAL;
			}
			else if (tipoVisualizacao == POR_MODALIDADE) {

				widget.tipoVisualizacao = TODAS_UNIDADES;
				widget.labelInfo = LABEL_INFO_VND_TOT + ": R$ " + templateManager.container.allData.totalVendas[0].TOTALVEND.formatMoney(2, ',', '.');

				widget.chartXAxisField = "UNIDADE";

				serieColors = ["#6ae2dc", "#e673d4", "#E6C973", "#4d62b7", "#80C8B5", "#4f4860"];

				grafico = [ChartFactoryController.getPieChart(serieColors, 'MODALIDADE', 'TOTALVEND', 'TOTALVEND')];
				
				widget.configButtonIcon = "";
			}

			ChartController.setWidgetChartSeries(widget, grafico);
			setDataSourceCharts(widget);
			widget.updateChart();
			templateManager.updateTemplate();
		}

	};

	this.trocarGraficoTicketMedio = function(inicializacao) {
		var widget = getWidgetTicketMedio();
		var grafico;

		if (widget.unidades > 1 || inicializacao) {
			if (widget.tipoVisualizacao == TODAS_UNIDADES) {

				widget.tipoVisualizacao = POR_UNIDADE;
				widget.labelInfo = LABEL_INFO_TCK_UNI + " - Média geral: R$ " + templateManager.container.allData.ticketMedio[0].TICKETMEDIO.formatMoney(2, ',', '.');

				grafico = [ChartFactoryController.getBarChart("#4db6ac", "TICKETMEDIO", "Ticket Médio", "value", false),
					ChartFactoryController.getLineChart('Meta', 'META', 0)
				];

			}
			else if (widget.tipoVisualizacao == POR_UNIDADE) {

				widget.tipoVisualizacao = TODAS_UNIDADES;
				widget.labelInfo = "Meta Ticket Médio: " + widget.dataSourcePorUnidade.data[0].META.formatMoney(2, ',', '.');

				widget.dataSource = {};
				
				if(widget.dataSourcePorUnidade.data[0].META == 0) {
					widget.dataSourcePorUnidade.data[0].META = widget.dataSourcePorUnidade.data[0].TICKETMEDIO;
				}

				grafico = [ChartFactoryController.getProgressChart(widget.dataSourcePorUnidade.data[0].TICKETMEDIO, widget.dataSourcePorUnidade.data[0].META)];
			}

			self.inicializar(widget, grafico);

		}
	};

	var getWidgetVendasRealizadas = function() {
		return templateManager.container.getWidget('VENDASREALIZADAS');
	};

	var getWidgetTicketMedio = function() {
		return templateManager.container.getWidget('TICKETMEDIO');
	};

	var getWidgetVendaModalidade = function() {
		return templateManager.container.getWidget('VENDAMODALIDADE');
	};

	var getWidgetDonutVendas = function() {
		return templateManager.container.getWidget('DONUTVENDAS');
	};

	var getDashboardData = function() {
		var data = [
			{
				'name': "NRORG",
				'operator': "=",
				'value': getLocalVar('NRORG')
			},
			{
				"name": "CDOPERADOR",
				"operator": "=",
				"value": getLocalVar('CDOPERADOR')
			},
			{
				"name": "DIASANTERIORES",
				"operator": "=",
				"value": templateManager.container.diasAnteriores
			},
			{
				"name": "DATAREGISTRO",
				"operator": "=",
				"value": templateManager.container.dashboardData
			}
		];

		if(!window.showMultipleFiliaisOnDashboard) {
			data.push(
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value": getLocalVar('CDFILIAL')
				}
			);
		}

		restEngine.post(
			'product#/getDashboardData', {
				'requestType': 'FilterData',
				'filter': data
			}, undefined, undefined, undefined, undefined, 8001000
		).then(function(response) {
			templateManager.container.allData.status = response.dataset.status;
			if (templateManager.container.allData.status.STATUS != 100) {
				templateManager.container.allData.totalVendasDia = response.dataset.getQuantidadeVendasConcluidas[0].VENDAS;
				templateManager.container.allData.totalVendasCanceladasDia = response.dataset.getQuantidadeVendasCanceladas[0].VENDAS;
				templateManager.container.allData.totalVendasPorFilial = response.dataset.getTotalVendaFilial;
				templateManager.container.allData.totalVendas = response.dataset.getTotalVenda;
				templateManager.container.allData.ticketMedio = response.dataset.getTicketMedio;
				templateManager.container.allData.ticketMedioPorFilial = response.dataset.getTicketMedioFilial;
				templateManager.container.allData.vendaModalidade = response.dataset.getVendaModalidade;
				templateManager.container.allData.vendaModalidadePorFilial = response.dataset.getVendaModalidadeFilial;
				templateManager.container.allData.vendaHora = response.dataset.getVendaHora;
			} else {
				templateManager.container.getWidget(SALES_CONCLUDED).highlight =
				templateManager.container.getWidget(SALES_CANCELED).highlight = 0;
			}
			
			ScreenService.changeLoadingMessage("Aguarde...");
			setValoresWidgets();
		});
	};

	this.syncDashData = function() {
		ScreenService.changeLoadingMessage("Atualizando informações de vendas...");
		getDashboardData();
	
	};

	var setDataSourceCharts = function(widget) {
		var cdfilial;

		if (widget.tipoVisualizacao == POR_UNIDADE)
			widget.dataSource.data = widget.dataSourcePorUnidade.data;
		else if (widget.tipoVisualizacao == TODAS_UNIDADES)
			widget.dataSource.data = widget.dataSourceTotal.data;
		else if (widget.tipoVisualizacao == MAIORES_VENDAS) {
			cdfilial = widget.currentRow.LABELFILIAL.substring(0, 4);
			widget.dataSource.data = getValorVendidoUnidade(cdfilial);
		}
		else if (widget.tipoVisualizacao == POR_MODALIDADE) {

			widget.labelInfo = widget.currentRow.UNIDADE;

			if (widget.currentRow.UNIDADE)
				cdfilial = widget.currentRow.UNIDADE.substring(0, 4);
			else
				cdfilial = templateManager.container.allData.vendaModalidadePorFilial[0].CDFILIAL;
			setVendaModalidadeUnidade(cdfilial);

		}

		if (!!widget.chart)
			widget.chart.redraw();
	};

	var setValoresWidgets = function() {

		if (self.averiguarDataVendas() != 100) {
			setValorChartVendaPorFilial();
			setValorChartVenda();
			setTicketMedioPorFilial();
			setVendaModalidade();
			setVendaModalidadePorFilial();
			setDonutVendas();
			self.inicializarGraficoVenda();
			setValorTotalQuantidadeVendasDia();
			setValorTotalQuantidadeVendasCanceladasDia();
			self.inicializarGraficoModalidade();
			self.inicializarGraficoTicket();
			self.inicializarWidgetsValor();
		}

	};

	var setValorTotalQuantidadeVendasDia = function() {
		templateManager.container.getWidget(SALES_CONCLUDED).highlight = templateManager.container.allData.totalVendasDia;
	};

	var setValorTotalQuantidadeVendasCanceladasDia = function() {
		templateManager.container.getWidget(SALES_CANCELED).highlight = templateManager.container.allData.totalVendasCanceladasDia;
	};

	var setValorChartVendaPorFilial = function() {
		var widget = getWidgetVendasRealizadas();
		widget.dataSourcePorUnidade.data = templateManager.container.allData.totalVendasPorFilial;
		setDataSourceCharts(widget);
	};

	var setValorChartVenda = function() {
		var widget = getWidgetVendasRealizadas();
		widget.dataSourceTotal.data = templateManager.container.allData.totalVendas;
		setDataSourceCharts(widget);
	};

	var setTicketMedio = function() {
		var widget = getWidgetTicketMedio();
		var dados = templateManager.container.allData.ticketMedio;

		dados = [{
			"NOME": "Meta Geral",
			"VALOR": dados[0].META
		}, {
			"NOME": "Ticket Médio Geral",
			"VALOR": dados[0].TICKETMEDIO
		}];
		widget.dataSourceTotal.data = dados;

		setDataSourceCharts(widget);
	};

	var setTicketMedioPorFilial = function() {
		var widget = getWidgetTicketMedio();
		widget.dataSourcePorUnidade.data = templateManager.container.allData.ticketMedioPorFilial;
		setDataSourceCharts(widget);
	};

	var setVendaModalidade = function() {
		var widget = getWidgetVendaModalidade();

		var dadosModalidade = templateManager.container.allData.vendaModalidade;

		widget.dataSourceTotal.data = dadosModalidade;

		setDataSourceCharts(widget);
	};

	var setVendaModalidadeUnidade = function(cdfilial) {
		var widget = getWidgetVendaModalidade();

		widget.dataSource.data = findModalidade(cdfilial);
	};

	var findModalidade = function(cdfilial) {
		var dados = [];
		var modalidades = ["Mesa", "Balcão", "Delivery", "TAA", "Comanda", "Outros"];

		var vendas = templateManager.container.allData.vendaModalidadePorFilial;

		modalidades.forEach(function(data) {
			var info = {
				"UNIDADE": "Carregando",
				"TOTALVEND": 0,
				"MODALIDADE": data,
				"META": 0
			};
			dados.push(info);
		});

		vendas.forEach(function(data) {
			if (data.CDFILIAL == cdfilial) {
				dados.forEach(function(arrayDados) {
					arrayDados.UNIDADE = data.LABELFILIAL;
					if (arrayDados.MODALIDADE == data.MODALIDADE) {
						arrayDados.UNIDADE = data.LABELFILIAL;
						arrayDados.TOTALVEND = data.TOTALVEND;
						arrayDados.META = data.METAMODALIDADE;
					}
				});
			}
		});

		return dados;
	};

	var setVendaModalidadePorFilial = function() {
		var widget = getWidgetVendaModalidade();

		var dadosModalidade = templateManager.container.allData.vendaModalidadePorFilial;

		var arrayDados = [];
		var dadosReestruturados = {};

		dadosModalidade.forEach(function(data) {
			dadosReestruturados = {
				"UNIDADE": data.LABELFILIAL,
				"META": data.META,
				"MES": getValorVendidoModalidade('Mesa', data.CDFILIAL),
				"TAA": getValorVendidoModalidade('TAA', data.CDFILIAL),
				"DLV": getValorVendidoModalidade('Delivery', data.CDFILIAL),
				"BAL": getValorVendidoModalidade('Balcão', data.CDFILIAL),
				"CMD": getValorVendidoModalidade('Comanda', data.CDFILIAL),
				"OUTROS": getValorVendidoModalidade('Outros', data.CDFILIAL)
			};
			arrayDados.push(dadosReestruturados);
		});
		widget.dataSourcePorUnidade.data = arrayDados;
		setDataSourceCharts(widget);
	};

	var getValorVendidoModalidade = function(modalidade, filial) {
		var dadosModalidade;

		if (filial)
			dadosModalidade = templateManager.container.allData.vendaModalidadePorFilial;
		else
			dadosModalidade = templateManager.container.allData.vendaModalidade;

		var valor = 0;

		dadosModalidade.forEach(function(data) {
			if ((!!filial && (data.CDFILIAL === filial && data.MODALIDADE === modalidade)) || !filial && (data.MODALIDADE === modalidade)) {
				valor = data.TOTALVEND;
			}
		});

		return valor;
	};

	var getValorVendidoUnidade = function(filial) {
		var vendasHora;

		vendasHora = templateManager.container.allData.vendaHora;

		var valor = 0;

		vendasHora.forEach(function(data) {
			if (data.LABELFILIAL === filial) {
				valor = data.VENDAS;
			}
		});

		return valor;
	};

	var setDonutVendas = function() {
		var widget = getWidgetDonutVendas();
		widget.dataSource.data = templateManager.container.allData.totalVendasPorFilial;
		widget.chart.redraw();
	};

	var setDonutVendasMeta = function(cdfilial) {
		var widget = getWidgetDonutVendas();
		var dados = templateManager.container.allData.totalVendasPorFilial;

		dados.forEach(function(data) {
			if (data.CDFILIAL == cdfilial) {
				widget.dataSource.data = data.DADOSMETA;
			}
		});
		widget.chart.redraw();
	};

	this.inicializarGraficoModalidade = function() {
		var widget = getWidgetVendaModalidade();
		var unidades = getWidgetVendasRealizadas().dataSourcePorUnidade.data.length;

		if (unidades <= 1) {

			widget.tipoVisualizacao = POR_UNIDADE;
			self.trocarGraficoVendaModalidade(true);

		}
		else {
			widget.tipoVisualizacao = POR_MODALIDADE;
			self.trocarGraficoVendaModalidade();
		}
	};

	this.inicializarGraficoVenda = function() {
		var widget = getWidgetVendasRealizadas();
		var unidades = widget.dataSourcePorUnidade.data.length;

		if (unidades <= 1) {
			widget.currentRow = widget.dataSourcePorUnidade.data[0];
			widget.unidades = 1;
			widget.tipoVisualizacao = 'S';
		}
		else {
			widget.unidades = 2;
			widget.tipoVisualizacao = 'M';
		}
		self.trocarGraficoVendasRealizadas(true);
	};

	this.inicializarGraficoTicket = function() {
		var widget = getWidgetTicketMedio();
		var unidades = widget.dataSourcePorUnidade.data.length;

		widget.tipoVisualizacao = 'T';

		if (unidades <= 1) {
			widget.unidades = 1;
			widget.tipoVisualizacao = 'S';
		}

		self.trocarGraficoTicketMedio(true);
	};

	this.inicializarWidgetsValor = function() {
		var widVendascanceladas = templateManager.container.getWidget(SALES_CANCELED);
		var widFcCupomPendentes = templateManager.container.getWidget('V_FECHACAIXAPEND');
		var widVendasNaoConsoli = templateManager.container.getWidget('V_APROVMOVCARD');
		var widFechamentoPenden = templateManager.container.getWidget('V_FECHACAIXAPEND');

		widVendascanceladas.color =
			widFcCupomPendentes.color =
			widVendasNaoConsoli.color =
			widFechamentoPenden.color = "#b51313";

		if (templateManager.container.allData.totalVendasCanceladasDia == 0)
			widVendascanceladas.color = "#18b28a";
		if (widFcCupomPendentes.notification == 0)
			widFcCupomPendentes.color = "#18b28a";
		if (widVendasNaoConsoli.notification == 0)
			widVendasNaoConsoli.color = "#18b28a";
		if (widFechamentoPenden.notification == 0)
			widFechamentoPenden.color = "#18b28a";

		widVendascanceladas.redraw();
		widFcCupomPendentes.redraw();
		widVendasNaoConsoli.redraw();
		widFechamentoPenden.redraw();

		templateManager.updateTemplate();
	};

	this.inicializar = function(widget, grafico) {
		ChartController.setWidgetChartSeries(widget, grafico);
		setDataSourceCharts(widget);
		widget.updateChart();
		templateManager.updateTemplate();
	};

	this.averiguarDataVendas = function() {
		var dados = templateManager.container.allData.status;
		var dias = templateManager.container.diasAnteriores;

		if (dados.STATUS == 100) {
			if (dias == 0)
				ScreenService.errorNotification("Não foi possível recuperar nenhuma venda nos últimos 10 dias.", 60000, "");
			else
				ScreenService.errorNotification("Não foi possível recuperar nenhuma venda.", 60000, "");
		}
		else if (dados.STATUS == 300) {
			if (dados.DATA) {
				ScreenService.alertNotification("Exibindo vendas do dia " + dados.DATA + ".", 60000, "");
			}
			else
				ScreenService.alertNotification("Não foi possível recuperar as vendas de hoje.", 60000, "");
		}
		else if (dados.STATUS == 200) {
			if (templateManager.container.diasAnteriores < 0) {
				ScreenService.alertNotification("Exibindo vendas do dia " + dados.DATA + ".", 60000, "");
			}
			templateManager.container.diasAnteriores = 0;
		}

		templateManager.container.dashboardData = dados.DATA;
		return dados.STATUS;
	};

	this.getDiaAnterior = function() {
		var dados = templateManager.container.allData.status;
		if (dados.STATUS != 100) {
			templateManager.container.dashboardData = moment(templateManager.container.dashboardData, 'DD/MM/YY').subtract(1, "days").format('DD/MM/YY');
			templateManager.container.diasAnteriores--;
			verificarBotao();
			getDashboardData();
		}
		else {
			templateManager.container.diasAnteriores = 0;
			ScreenService.errorNotification("Não foi possível recuperar nenhuma venda.", 60000, "");
		}
	};

	this.getProxDia = function() {

		templateManager.container.diasAnteriores++;

		templateManager.container.dashboardData = moment(templateManager.container.dashboardData, 'DD/MM/YY').add(1, "days").format('DD/MM/YY');
		verificarBotao();
		getDashboardData();

	};

	var verificarBotao = function() {
		if (templateManager.container.diasAnteriores < 0) {
			templateManager.container.widgets[0].actions[2].isVisible = true;
		}
		else {
			templateManager.container.widgets[0].actions[2].isVisible = false;
		}
		templateManager.updateTemplate();
	};
	
	this.buttonConfig = function() {
		var widget = getWidgetVendasRealizadas();
		if (widget.unidades > 1 && widget.tipoVisualizacao == MAIORES_VENDAS) {
			this.trocarGraficoVendasRealizadas();
		}
	};
	
	this.buttonConfigVendaDiaModalidade = function() {
		var widget = getWidgetVendaModalidade();
		
		widget.tipoVisualizacao = POR_MODALIDADE;
		this.trocarGraficoVendaModalidade();
	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('MainDashboardController', MainDashboardController);
});

/* global Configuration */
/* global getLocalVar */
/* global moment */


// FILE: ./assets/js/controllers/ManageDashboardController.js
function ManageDashboardController (eventAggregator, templateManager, ScreenService, localStorageEngine, ManageDashboardService, MainDashboardController, GRManageDashboardService) {
    
    var   DASHBOARD_CONTAINER_NAME  = 'dashboard';
    
    // New event on engine.js -> After all localvars are set
    var   EVENT_LOGIN_SUCCESS    = 'onAllLocalVarsSetted';
    
    var   SALES_CONCLUDED           = 'salesConcluded',
          SALES_CANCELED            = 'salesCanceled',
          MOST_SOLD                 = 'mostSold',
          GRAFIC_PIE_MONTHLY        = 'graficPieMonthly',
          LIST_MONTHLY              = 'listMonthly',
          GRAFIC_PIE_DAILY          = 'graficPieDaily',
          LIST_DAILY                = 'listDaily',
          CAIXA_PENDENTE            = 'fechCaixPend',
          CUPOM_PENDENTE            = 'fechCupomPend',
          CONSOLIDACAO_PENDENTE     = 'vendasNaoConsolidadas';
    
    //eventAggregator.subscribe(EVENT_LOGIN_SUCCESS, initializeDashboardValues);
    
    // Initializing dashboards, according to new login and TekLib
    function initializeDashboardValues () {
        setDashboardCards();
        resizeScreen();
    }
    
    // Updates dashboard's card's values
    function setDashboardCards () {
        var DTATU = moment().format('DD/MM/YYYY');
        
        // Param for
        if(window.showMultipleFiliaisOnDashboard) {
            ManageDashboardService.getCaixaPendente().then(function(response) {
                templateManager.container.getWidget(CAIXA_PENDENTE).notification = response.dataset.getFechamentoCaixaPendente[0].COUNT;
            });
            
            ManageDashboardService.getCupomPendente().then(function(response) {
                templateManager.container.getWidget(CUPOM_PENDENTE).notification = response.dataset.getFechamentoCupomPendente[0].COUNT;
            }).then(resizeScreen);
            
            ManageDashboardService.getConsolidacaoPendente().then(function(response) {
                templateManager.container.getWidget(CONSOLIDACAO_PENDENTE).notification = response.dataset.getConsolidacaoVendaPendente[0].COUNT;
            });
        } else {
            GRManageDashboardService.getCaixaPendente().then(function(response) {
                templateManager.container.getWidget(CAIXA_PENDENTE).notification = response.dataset.getFechamentoCaixaPendente[0].COUNT;
            });
            
            GRManageDashboardService.getCupomPendente().then(function(response) {
                templateManager.container.getWidget(CUPOM_PENDENTE).notification = response.dataset.getFechamentoCupomPendente[0].COUNT;
            }).then(resizeScreen);
            
            GRManageDashboardService.getConsolidacaoPendente().then(function(response) {
                templateManager.container.getWidget(CONSOLIDACAO_PENDENTE).notification = response.dataset.getConsolidacaoVendaPendente[0].COUNT;
            });
        }
        
        handleCNCCard();
        
    }
    
    // Wait 10 seconds for Dashboard to load completely and update it
    var resizeScreen = function() {
        setTimeout(function() {
            $(window).resize();
            MainDashboardController.inicializarWidgetsValor();
        }, 3000);
    };
    
    // Redirect to CNC 
    this.redirectCncErrorLog = function (args) {
        localStorageEngine.setLocalVar("shouldNotShowFilter", true);
        
        this.openWindow('cnc#cnc02200_error_log');
    };
    
    
    this.updateNotificationsValue = function (widget) {
        if (!!widget.dataSource.data) 
            widget.notification = widget.dataSource.data.shift().COUNT;
    };
   
    // Shows CNC card and atributes to him backend's value
    var handleCNCCard = function () {
        var widget = templateManager.container.getWidget("cncConcErrosCard");
        
        return ManageDashboardService.getDivergenciasConciliacao().then(function(response) {
            widget.notification = response.dataset.findDivergenciasConciliacao[0].COUNT;
            widget.isVisible = (widget.notification > 0);
        });
        
    };
    
    // Using new TekLib method to redirect to modules correctly.  
    this.openWindow = function (windowName, newWindow) {
        ManageDashboardService.requestModulesMetadata().then(function (modules) {
            var subModule = windowName. split('#')[0];
            var module = subModule.split('_')[0];
            var url = window.location.origin + '/' + modules[module].baseUrl + "/#/" + windowName;
            if (ScreenService.openLink) {
                ScreenService.openLink(url, newWindow);
            } else {
                ScreenService.openWindow(windowName);
            }
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ManageDashboardController', ManageDashboardController);
});

// FILE: ./assets/js/controllers/NewDashboardCorporativoController.js
function NewDashboardCorporativoController (eventAggregator, templateManager, ScreenService, localStorageEngine, DashboardCorporativoService, MainDashboardController, General) {
    
    var   DASHBOARD_CONTAINER_NAME  = 'dashboardCorporativo';
    
    // New event on engine.js -> After all localvars are set
    var   EVENT_LOGIN_SUCCESS    = 'onAllLocalVarsSetted';
    
    var   V_QTTICKET            = 'V_QTTICKET',
          V_TOTVEND             = 'V_TOTVEND',
          V_AVGTICKET           = 'V_AVGTICKET',
          V_CANCTICKET          = 'V_CANCTICKET',
          V_FECHACAIXAPEND      = 'V_FECHACAIXAPEND',
          V_APROVMOVCARD        = 'V_APROVMOVCARD',
          V_DIFAPURACARD        = 'V_DIFAPURACARD',
          V_CUPOMPENDCARD       = 'V_CUPOMPENDCARD',
          V_ITESTPENDCARD       = 'V_ITESTPENDCARD',
          V_QTNFEPEND       = 'V_QTNFEPEND',
          V_QTNFEDIGIT       = 'V_QTNFEDIGIT',
          V_QTNFSPEND       = 'V_QTNFSPEND',
          V_QTNFSDIGIT       = 'V_QTNFSDIGIT',
          V_QTNFEIMPORTXML       = 'V_QTNFEIMPORTXML',
          V_QTNFEDIGITHAND       = 'V_QTNFEDIGITHAND',
          V_QTNFSDIGITHAND       = 'V_QTNFSDIGITHAND',
          V_PRODIRREG       = 'V_PRODIRREG',
          V_VENCIMENTO       = 'V_VENCIMENTO',
          G_VENDASREALIZADAS       = 'VENDASREALIZADAS',
          G_GRAPHTICKETMEDIO       = 'GRAPHTICKETMEDIO',
          G_GRAPHQTDTCS       = 'GRAPHQTDTCS',
          G_GRAPHMODVEND       = 'GRAPHMODVEND',
          G_GRAPHPAYMENT       = 'GRAPHPAYMENT',
          G_GRAPHSALESFORDAY       = 'GRAPHSALESFORDAY',
          T_MAIORCUSTO       = 'MAIORCUSTO',
          T_MENORCUSTO       = 'MENORCUSTO',
          T_PRODMAISAJUST       = 'PRODMAISAJUST',
          T_CONTAGEMPEND       = 'CONTAGEMPEND',
          T_CONTASPAGAR       = 'CONTASPAGAR',
          T_CONTASRECEBER       = 'CONTASRECEBER',
          T_SALDOEMCONTAS       = 'SALDOEMCONTAS',
          T_CMV               = 'CMV',
          T_STATUSNOTA       = 'STATUSNOTA';
    
    eventAggregator.subscribe(EVENT_LOGIN_SUCCESS, initializeDashboardValues);
    
    // Initializing dashboards, according to new login and TekLib
    function initializeDashboardValues () {
        setDashboardCards(getLocalVar('CDFILIAL'), null, 'S');
        setStripe(getLocalVar('CDFILIAL'), null, 'S');
        resizeScreen();
    }
    
    // Updates dashboard's card's values
    function setDashboardCards (CDFILIAL, DTVNDCARDS, CHECK) {
        // Param for
        DashboardCorporativoService.getV_QTTICKET(CDFILIAL, DTVNDCARDS, CHECK).then(function(response) {
            var cards = response.dataset.getCards[0];
            var container = templateManager.container;
            
            //Graphics
            container.getWidget(G_VENDASREALIZADAS).dataSource.data = response.dataset.getGraph;
            container.getWidget(G_GRAPHTICKETMEDIO).dataSource.data = response.dataset.getGraph;
            container.getWidget(G_GRAPHQTDTCS).dataSource.data = response.dataset.getGraph;
            container.getWidget(G_GRAPHMODVEND).dataSource.data = response.dataset.getSaleTypeGraph;
            container.getWidget(G_GRAPHPAYMENT).dataSource.data = response.dataset.getSalePaymentGraph;
            container.getWidget(G_GRAPHSALESFORDAY).dataSource.data = response.dataset.getSaleForDayGraph;
            
            //table
            container.getWidget(T_MAIORCUSTO).dataSource.data = response.dataset.getT_MAIORCUSTO;
            container.getWidget(T_MENORCUSTO).dataSource.data = response.dataset.getT_MENORCUSTO;
            container.getWidget(T_PRODMAISAJUST).dataSource.data = response.dataset.getT_PRODMAISAJUST;
            container.getWidget(T_CONTAGEMPEND).dataSource.data = response.dataset.getT_CONTAGEMPEND;
            
            container.getWidget(T_CONTASPAGAR).dataSource.data = response.dataset.getT_CONTASPAGAR;
            container.getWidget(T_CONTASRECEBER).dataSource.data = response.dataset.getT_CONTASRECEBER;
            container.getWidget(T_SALDOEMCONTAS).dataSource.data = response.dataset.getT_SALDOEMCONTAS;
            container.getWidget(T_STATUSNOTA).dataSource.data = response.dataset.getT_STATUSNOTA;
            
            //cards
            container.getWidget(V_QTTICKET).notification = cards.QTTICKETCARD ? cards.QTTICKETCARD : 0;
            container.getWidget(V_CANCTICKET).notification = cards.CANCVENDCARD ? cards.CANCVENDCARD : 0;
            container.getWidget(V_FECHACAIXAPEND).notification = cards.FECHCAIXPENDCARD ? cards.FECHCAIXPENDCARD : 0;
            container.getWidget(V_APROVMOVCARD).notification = cards.APROVMOVCARD ? cards.APROVMOVCARD : 0;
            //container.getWidget(V_DIFAPURACARD).leftNotification = 'Qtd.:'+(cards.QTDIFAPURACARD == undefined ? '0' : cards.QTDIFAPURACARD);
            container.getWidget(V_CUPOMPENDCARD).notification = cards.CUPOMPENDCARD ? cards.CUPOMPENDCARD : 0;
            container.getWidget(V_ITESTPENDCARD).notification = cards.ITESTPENDCARD ? cards.ITESTPENDCARD : 0;
            container.getWidget(V_QTNFEPEND).notification = cards.QTNFSPEND ? cards.QTNFSPEND : 0;
            container.getWidget(V_QTNFEDIGIT).notification = cards.QTNFEDIGIT ? cards.QTNFEDIGIT : 0;
            container.getWidget(V_QTNFSPEND).notification = cards.QTNFSPEND ? cards.QTNFSPEND : 0;
            container.getWidget(V_QTNFSDIGIT).notification = cards.QTNFSDIGIT ? cards.QTNFSDIGIT : 0;
            container.getWidget(V_QTNFEIMPORTXML).notification = cards.QTNFEIMPORTXML ? cards.QTNFEIMPORTXML : 0;
            container.getWidget(V_QTNFEDIGITHAND).notification = cards.QTNFEDIGITHAND ? cards.QTNFEDIGITHAND : 0;
            container.getWidget(V_QTNFSDIGITHAND).notification = cards.QTNFSDIGITHAND ? cards.QTNFSDIGITHAND : 0;
            container.getWidget(V_PRODIRREG).notification = cards.PRODIRREG ? cards.PRODIRREG : 0;
            container.getWidget(V_TOTVEND).notification = cards.TOTVENDCARD ? parseFloat(cards.TOTVENDCARD) : 0;
            container.getWidget(V_AVGTICKET).notification = cards.AVGTICKETCARD ? parseFloat(cards.AVGTICKETCARD) : 0;
            container.getWidget(V_VENCIMENTO).notification = cards.VENCIMENTO;
            
            var widgetCards = [
                V_QTTICKET,
                V_CANCTICKET,
                V_FECHACAIXAPEND,
                V_APROVMOVCARD,
                V_DIFAPURACARD,
                V_CUPOMPENDCARD,
                V_ITESTPENDCARD,
                V_QTNFEPEND,
                V_QTNFEDIGIT,
                V_QTNFSPEND,
                V_QTNFSDIGIT,
                V_QTNFEIMPORTXML,
                V_QTNFEDIGITHAND,
                V_QTNFSDIGITHAND,
                V_PRODIRREG,
                V_TOTVEND,
                V_AVGTICKET
            ];
            var today = moment().add(cards.VENCIMENTO, 'd').format('DD/MM/YYYY');
            if (cards.VENCIMENTO == 'V'){
                VanishCard(V_VENCIMENTO);
            }
            else if (cards.VENCIMENTO == 'SC'){
                ScreenService.showMessage('Atenção! Unidade possui caixas NFC-e, e não possui certificado digital configurado.', 'E');
                VanishCard(V_VENCIMENTO);
            }
            else if(cards.VENCIMENTO < '0'){
                ScreenService.showMessage('Atenção! '+parseFloat(cards.VENCIMENTO)*(-1)+' dias sem transmitir notas. Certificado Vencido desde: '+today, 'E');
                VanishCard(V_VENCIMENTO);
            }
            else if(parseFloat(cards.VENCIMENTO) < 30){
                UnvanishCard(V_VENCIMENTO);
                ScreenService.showMessage('Atenção! Certificado digital vence em '+parseFloat(cards.VENCIMENTO)+' dias', 'W');
            }
            else if(parseFloat(cards.VENCIMENTO) < 90){
                UnvanishCard(V_VENCIMENTO);
            }
            else{
                VanishCard(V_VENCIMENTO);
            }
            
            widgetCards.forEach(function(cardWidgetName) {
                container.getWidget(cardWidgetName).notification = 
                    (container.getWidget(cardWidgetName).notification + '').replace('.',  ',');  
            });
            container.getWidget(V_DIFAPURACARD).notification = 'Vr.:'+(cards.DIFAPURACARD == undefined ? '0': ((parseFloat(cards.DIFAPURACARD) + '').replace('.', ',') ));
            
            HandleColorsSales(container.getWidget(V_QTTICKET));
            HandleColorsSales(container.getWidget(V_TOTVEND));
            HandleColorsSales(container.getWidget(V_AVGTICKET));
            HandleColors(container.getWidget(V_CANCTICKET));
            HandleColors(container.getWidget(V_FECHACAIXAPEND));
            HandleColors(container.getWidget(V_APROVMOVCARD));
            HandleColors(container.getWidget(V_CUPOMPENDCARD));
            HandleColors(container.getWidget(V_ITESTPENDCARD));
            HandleColors(container.getWidget(V_PRODIRREG));
            
            HandleColorsToLeft(container.getWidget(V_DIFAPURACARD), cards.DIFAPURACARD);
            var WidgetCMV = container.getWidget(T_CMV);
            WidgetCMV.dataSource.data = response.dataset.getT_CMV;
            $(window).resize();
        }).then(function(){
            $(window).resize();
        });
        //handleCNCCard();
    }
    
    function VanishCard (Card){
        templateManager.container.getWidget(Card).isVisible = false;
        templateManager.container.getWidget(Card).reload();   
    }
    
    function UnvanishCard (Card){
        templateManager.container.getWidget(Card).isVisible = true;
        templateManager.container.getWidget(Card).reload();   
    }
    
    function HandleColorsToLeft (widget, notification) {
        if (notification > 0)
            widget.color = '#b51313';
        else 
            widget.color = '#18b28a';   
    }
    
    function HandleColors (widget) {
        if (widget.notification > 0)
            widget.color = '#b51313';
        else 
            widget.color = '#18b28a';   
    }
    
    function HandleColorsSales (widget) {
        if (widget.notification == 0)
            widget.color = '#b51313';
        else
            widget.color = '#18b28a';
    }
    
    this.cancelar = function(args) {
        var widget = args.owner.widget;
        var widgetPrincipal = templateManager.container.getWidget('widDashboard');
        ScreenService.closePopup();
        widgetPrincipal.activate();
        widgetPrincipal.reload();
        widget.fields.forEach(function(field){
			field.value("");
		});
    };
    
    this.filter = function(args) {
        var widget = args.owner.widget;
        var CDFILIAL = widget.currentRow.CDFILIAL? widget.currentRow.CDFILIAL: '';
        var DTVNDCARDS = widget.currentRow.DTVNDCARDS;
        var CHECK = widget.currentRow.CDFILIAL? 'S': 'A';
        if(widget.isValid()){
            setDashboardCards (CDFILIAL, DTVNDCARDS, CHECK);
            setStripe(CDFILIAL, DTVNDCARDS, CHECK);
            setLabelCMV(DTVNDCARDS);
            var widgetPrincipal = templateManager.container.getWidget('widDashboard');
            ScreenService.closePopup();
            widgetPrincipal.activate();
            widgetPrincipal.reload().then(function (){
                resizeScreen();
            });
            
            widget.fields.forEach(function(field){
    		});
        }
    };
    
    this.openFilterPopUp = function(args){
        var filterWidget = templateManager.container.getWidget('popupFilter');
        ScreenService.openPopup(filterWidget);
        filterWidget.activate();
        
		if(!filterWidget.currentRow.DTVNDCARDS)
		    filterWidget.currentRow.DTVNDCARDS = moment().format('DD/MM/YYYY');
		if (!filterWidget.currentRow.CDFILIAL) {
            filterWidget.currentRow.NMFILIAL = [getLocalVar('NMFILIAL')];
            filterWidget.currentRow.CDFILIAL = [getLocalVar('CDFILIAL')];
            filterWidget.getField('CDFILIAL').reload();
		}
    };
    
    // Wait 10 seconds for Dashboard to load completely and update it
    var resizeScreen = function() {
        setTimeout(function() {
            $(window).resize();
            //MainDashboardController.inicializarWidgetsValor();
        }, 3000);
    };
    
    // Redirect to CNC 
    this.redirectCncErrorLog = function (args) {
        localStorageEngine.setLocalVar("shouldNotShowFilter", true);
        
        this.openWindow('cnc#cnc02200_error_log');
    };
    
    
    this.updateNotificationsValue = function (widget) {
        if (!!widget.dataSource.data) 
            widget.notification = widget.dataSource.data.shift().COUNT;
    };
   
    // Shows CNC card and atributes to him backend's value
    var handleCNCCard = function () {
        var widget = templateManager.container.getWidget("cncConcErrosCard");
        
        return DashboardCorporativoService.getDivergenciasConciliacao().then(function(response) {
            widget.notification = response.dataset.findDivergenciasConciliacao[0].COUNT;
            widget.isVisible = (widget.notification > 0);
        });
        
    };
    
    // Using new TekLib method to redirect to modules correctly.  
    this.openWindow = function (windowName, newWindow) {
        DashboardCorporativoService.requestModulesMetadata().then(function (modules) {
            var subModule = windowName. split('#')[0];
            var module = subModule.split('_')[0];
            var url = window.location.origin + '/' + modules[module].baseUrl + "/#/" + windowName;
            if (ScreenService.openLink) {
                ScreenService.openLink(url, newWindow);
            } else {
                ScreenService.openWindow(windowName);
            }
        });
    };
    
    // Set stripe values - Dashboard
	function setStripe (cdfilial, dtvndcards, check) {
	    
	    var stripeWidget = templateManager.container.getWidget("stripe");
	    
	    if(Array.isArray(cdfilial) && cdfilial.length > 1){
            stripeWidget.currentRow.FILIAL  = "Lista com " + cdfilial.length + " unidades selecionadas.";
            stripeWidget.currentRow.DATA = dtvndcards?dtvndcards:moment().format('DD/MM/YYYY');
	    }else{
            var filterFilial = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ];
            
            General.callRestEngine('/crud/filial', 'FilterData', filterFilial).then(function (filial) {
                stripeWidget.currentRow.FILIAL  = cdfilial + ' - ' + filial.dataset.filial[0].NMFILIAL;
                stripeWidget.currentRow.DATA = dtvndcards?dtvndcards:moment().format('DD/MM/YYYY');
            });
	    }
    }
    // Alterar Label CMV
	function setLabelCMV (dtvndcards) {
	    
	    var CMVField = templateManager.container.getWidget("CMV").getField("LABELFILIAL");
	    
	    if(dtvndcards == moment().format('DD/MM/YYYY')){
            CMVField.label = "CMV (Dia Anterior)";
            CMVField.widget.reload();
	    }else{
	        CMVField.label = "CMV";
            CMVField.widget.reload();
	    }
    }
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('NewDashboardCorporativoController', NewDashboardCorporativoController);
});
